"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var base_request_service_1 = require('./base-request.service');
var http_1 = require('@angular/http');
/**
 * BaseUserService
 * <br>
 * <strong>Usage</strong>
 * ```
 * import { Injectable } from '@angular/core';
 * import { BaseUserService } from 'donkeycode-angular2-tools/src/services/user-request.service';
 * import { config } from '../../config';
 *
 * @Injectable()
 * export class RequestService extends BaseUserService {
 *
 *   constructor() {
 *     super();
 *     super.init(config);
 *   }
 *
 * }
 * ```
 */
var BaseUserService = (function () {
    function BaseUserService() {
    }
    BaseUserService.prototype.init = function (config) {
        BaseUserService.config = config;
    };
    BaseUserService.getProfile = function (force) {
        var _this = this;
        if (force === void 0) { force = false; }
        if (!force && this.account && this.account.groups) {
            return new Promise(function (resolve, reject) {
                resolve(_this.account);
            });
        }
        var injector = core_1.ReflectiveInjector.resolveAndCreate([
            base_request_service_1.BaseRequestService, http_1.HTTP_PROVIDERS
        ]);
        var requestService = injector.get(base_request_service_1.BaseRequestService);
        return new Promise(function (resolve, reject) {
            requestService
                .get(BaseUserService.config.apiUrl.profile)
                .then(function (response) {
                _this.account = response;
                resolve(_this.account);
            }, function (error) {
                console.log(error);
                reject({});
            });
        });
    };
    BaseUserService.redirectLogin = function () { };
    BaseUserService.hasRole = function (role) {
        if (!this.account || !this.account.roles) {
            return false;
        }
        return this.account.roles.indexOf(role) !== -1;
    };
    BaseUserService.account = {};
    BaseUserService.config = {};
    BaseUserService = __decorate([
        core_1.Injectable(), 
        __metadata('design:paramtypes', [])
    ], BaseUserService);
    return BaseUserService;
}());
exports.BaseUserService = BaseUserService;
//# sourceMappingURL=base-user.service.js.map